"use strict";var http=require("http"),events=require("events"),fs=require("fs"),util=require("util"),path=require("path"),connect=require("connect"),simpleportal=require("./../simpleportal"),ResponseService=require("./../service/response"),Resourceinstaller=require("./../util/resourceinstaller"),Template=require("./../util/template"),Configuration=require("./configuration"),Restfulmongo=require("./../router/restfulmongo"),Routerclass=require("./../router/router"),Serviceloader=require("./../router/serviceloader"),ViewLoader=require("./../router/viewloader"),StartupLoader=require("./../router/startuploader"),PluginLoader=require("./../router/pluginloader"),FilterLoader=require("./../router/filterloader"),OauthLoader=require("./../router/oauthloader"),Notificationcenter=require("./../util/notificationcenter"),Logger=require("./../util/logger").Logger,DBPool=require("./dbpool"),moment=require("moment");var Server=module.exports=function Server(b){var a=this;events.EventEmitter.call(a);a.options=simpleportal.util.extendJSON({},Server.DEFAULTS,b);if(b&&b.configure){a.configure=b.configure}if(process.argv&&process.argv.length>2&&process.argv[2].indexOf("-mode=configuration")!=-1){a.options["mode-configuration"]=true}a.serverstatus="init";a._configuration={};a._routers=[];return a};util.inherits(Server,events.EventEmitter);Server.prototype.createServer=function(b){var a=this;if(!b||(b&&!b.disableautocreate)){simpleportal.util.checkDirSync(simpleportal.util.getServerPath("api"));simpleportal.util.checkDirSync(simpleportal.util.getServerPath("view"));simpleportal.util.checkDirSync(simpleportal.util.getServerPath("filter"));simpleportal.util.checkDirSync(simpleportal.util.getServerPath("resources"));simpleportal.util.checkDirSync(simpleportal.util.getServerPath("resources/public"));simpleportal.util.checkDirSync(simpleportal.util.getServerPath("resources/plugin"))}if(b&&b.install){a.options["resources-install"]=true}a.init()};Server.prototype.stopNodeServer=function(e,f,d){var a=this,b,c=path.dirname(e)+"/pid";if(!d){d={}}if(fs.existsSync(c)){b=fs.readFileSync(c)+"";if(require("is-running")(b)){process.kill(b)}else{f("Server is not running pid -"+b)}}else{f("no process id found for your server.")}};Server.prototype.forkNodeServer=function(f,h,e){var a=this,b,c=path.dirname(f)+"/pid";if(!e){e={}}console.log("Starting new server >"+f);if(fs.existsSync(c)){b=fs.readFileSync(c)+""}if(require("is-running")(b)){h("Server allready running with process id -"+b)}else{var d=require("child_process").fork;var g=d(f,[],{stdio:"pipe"});e.pid=g.pid;fs.writeFileSync(c,g.pid);g.on("exit",function(){fs.unlinkSync(c)});h(null,e)}};Server.prototype.init=function(){var a=this;if(a.options["resources-install"]){a.on("configuration.ready",function(){a.getLogger().info("Server:init@event[configuration.ready]","configuration.ready");if(a.getConfiguration("resources").dependencies){var l=a.getConfiguration("resources").dependencies;var m=0;if(l&&l.length>0){for(var j in l){var i=l[j];if(!i.disabled){i.resourcefolder=simpleportal.util.getServerPath(i.resourcefolder);i.resourcebundle=i.resourcename+".tar.gz";var k=new Resourceinstaller(i);k.install(function(n){if(n){a.getLogger().error("server:init",n)}if(m++==l.length-1){a.emit("db.init")}})}else{if(m++==l.length-1){a.emit("db.init")}}}}else{a.emit("db.init")}}else{a.emit("db.init")}})}a.on("db.error",function(i){a._dbError=i;a.startServer()});a.on("server.init",function(){a.initServer()});a.on("start",function(){a.getLogger().info("Main Server - on:start","calling module function start");a.viewloader.on("router.start",function(){a.getLogger().debug("Server.event@[router.start]","router.start is invoked.");a.server.use(ResponseService());a.server.use(a.getLogger().accessLog());var i=a.getTempDirectory();a.server.use("/view/system",connect["static"](simpleportal.util.getServerPath(i+"/system")));var j=simpleportal.util.clone(a._routers);initRouter(a,j,function(){a.getLogger().debug("Server.@start","finished calling all services init function.");a.serviceloader.startAll(function(){a.getLogger().debug("Server.@startAll","finished calling all services start function.");connect["static"]("/view",simpleportal.util.getServerPath(i+"/templates"));a.emit("dispatch.pre",{})})})});a.startuploader.on("router.start",function(){a.getLogger().info("Server","startuploader>>> -- router .start is called");a.viewloader.startAll()});a.startuploader.startAll()});a.on("dispatch.pre",function(){if(a.listeners("dispatch.ready").length==0){a.emit("dispatch.ready",{})}else{a.emit("dispatch.ready",{})}});a.on("dispatch.post",function(){a.server.use("/keep-alive",function(m,l){l.end()});var j=simpleportal.util.getServerPath(a.getConfiguration("resources").root+"public/");if(a.pluginloader.uiplugindir){a.server.use("/uiplugin",connect["static"](a.pluginloader.uiplugindir))}if(a.pluginloader.systemuiplugindir){a.server.use("/uiplugin",connect["static"](a.pluginloader.systemuiplugindir))}if(a.getConfiguration("loginuri")!="/login"){a.server.use("/login",function(m,l){l.header("Cache-Control","no-cache");l.redirect(a.getConfiguration("loginuri"),302,m)})}if(a.getConfiguration("dashboarduri")!="/dashboard"){a.server.use("/dashboard",function(m,l){l.header("Cache-Control","no-cache");l.redirect(a.getConfiguration("dashboarduri"),302,m)})}var k=[{url:"/theme",path:"/theme"},{url:"/session-locked",path:"/session-locked"},{url:"/terms-of-service",path:"/terms-of-service"}];registerPublicPageMapping(a,k);var i=simpleportal.util.getServerPath("resources/templates/public/pages");if(fs.existsSync(i)){a.server.use("/pages/",function(n,l,m){setDynamicPage(a,n.url,i,n,l,m)})}a.server.use("/pages/",function(n,l,m){if(n.publicpagelayout){m()}else{setDynamicPage(a,n.url,a.getServerCorePath("resources/templates/public/pages"),n,l,m)}});a.server.use("/pages/",function(n,l,m){sendDynamicPage(a,n.url,n,l,m)});updateServerWebpages(a);if(a.getConfiguration("homeuri")&&a.getConfiguration("homeuri")!="/"){a.getLogger().info("Server","Home uri is ::: "+a.getConfiguration("homeuri"));a.server.use("/",function(n,l,m){if((n.url=="/home/"&&!a.getConfiguration("homeuri")!="/home")||n.url=="/"){l.redirect(a.getConfiguration("homeuri"),301,n)}else{if(m){m()}}})}});a.on("dispatch.ready",function(){a.server.use(a.router.getDispatchHandler());a.emit("dispatch.post",{})});a.on("services.ready",function(){a.startServer()});a.on("restart",function(){a.getLogger().info("Server","Restart is called")});a.on("shutdown",function(i){a.getLogger().info("Server","Server shutdown is called.");a.serviceloader.shutdownAll(function(j){if(j){a.getLogger().error("Server",j)}else{if(a.listeners("services.shutdown").length==0){a.emit("server.exit")}else{a.emit("services.shutdown")}}})});a.on("server.exit",function(i){process.exit()});process.on("SIGTERM",function(){a.stopServer()});process.on("SIGINT",function(){a.stopServer()});process.on("uncaughtException",function(i,j){console.error("Unknown exception "+i+"");console.trace(i);console.log(j)});var e=require("os");var g=e.networkInterfaces();var d=false;for(var c in g){for(var f in g[c]){var b=g[c][f];if(!d&&b.family==="IPv4"&&!b.internal){a.setConfiguration("hostip",b.address);d=true}}}var h=new Configuration({defaultfile:a.getServerCorePath("configuration.json")});h.read(function(l,j){if(!h.extfile){a.enable("mode-configuration")}a.setConfiguration(h.getConfiguration());a.setConfiguration("simpleportal_version",simpleportal.version);var k=simpleportal.util.extendJSON({},a.getConfiguration("logger")),i=a.getConfiguration("resources");if(!k.root||!(k.root.indexOf(".")==0||k.root.indexOf("/")==0)){k.root=simpleportal.util.appendFilePath(i.datadir,k.root||"log")}k.root=simpleportal.util.getServerPath(k.root);a.logger=new Logger(k);a.emit("server.init")})};function initRouter(a,b,c){a.getRouter(b.splice(0,1)).initRouter(a.router,function(d,e){if(!b||b.length==0){c()}else{initRouter(a,b,c)}})}Server.prototype.stopServer=function(){var a=this;a.emit("shutdown")};Server.prototype.closeServer=function(){var a=this;process.exit()};Server.prototype.startServer=function(){var a=this;if(a.serverstatus!="running"){try{var c=connect.createServer();a.server=c;a.configure();a.emit("start",{});c.listen(a.getConfiguration("port",9665));a.getLogger().info("Server","Server listening on port -- "+a.getConfiguration("port",9665));a.serverstatus="running";a.emit("server.ready")}catch(b){a.getLogger().error("server:startServer",b)}}else{a.getLogger().info("Server","Server is already running- "+a.serverstatus)}};Server.prototype.configure=function(){var a=this,e=simpleportal.util.getServerPath(a.getConfiguration("resources").root+"public/");a.server.use(connect.compress({filter:function(j,i){return/html|image|text|css|javascript/.test(i.header("Content-Type"))}}));var h=a.getConfiguration("favicon");if(h&&h.length>0&&h[0].content){var d=a.getConfiguration("favicon")[0],f=new Buffer(d.content,"base64");a.server.use(connect.favicon(f))}else{if(fs.existsSync(e+"/favicon.ico")){a.server.use(connect.favicon(e+"/favicon.ico"))}else{if(fs.existsSync(a.getServerCorePath("resources/favicon.ico"))){a.server.use(connect.favicon(a.getServerCorePath("resources/favicon.ico")))}}}var c=a.getConfiguration("logo");if(c&&c.length>0&&c[0].content){var g=c[0],b=new Buffer(g.content,"base64");a.server.use("/logo",function(j,i){i.end(b)})}if(fs.existsSync(e)){a.server.use(connect["static"](e))}if(a.getConfiguration("resources").publicdirs&&typeof a.getConfiguration("resources").publicdirs.length!="undefined"){a.getConfiguration("resources").publicdirs.forEach(function(i){if(fs.existsSync(i)){a.server.use(connect["static"](i))}})}if(a._dbError){a.server.use((function(){return function(k,i,j){sendException(a,i,{exception:a._dbError})}})())}};var sendException=function(a,c,d){if(!d){return}d.exceptionfile=simpleportal.rootdir+"/resources/templates/exception.html.ejs";d.data={serverconfig:a.getConfiguration()};var b=new Template(d);b.render(c)};Server.prototype.configureconnect=function(){var a=this;a.getLogger().info("Server:configureconnect","configuring the connect ");if(a.options["mode-configuration"]){a.getLogger().info("Simpleportal - Server:configureconnect","SKIPPING Default Sever functions")}};Server.prototype.initServer=function(d){var a=this;a.getLogger().debug("Server:initServer","Initilizing the server.");if(a.getConfiguration("notificationcenter")){a.notificationcenter=new Notificationcenter({osnotification:a.getConfiguration("osnotification"),title:a.getConfiguration("title")})}if(a.getConfiguration("db")){var c=a.getConfiguration("db").use;var b=a.getConfiguration("db")[c];a.dbpool=new DBPool();a.dbpool.registerDB("default",b);a.dbpool.getInstance("default",function(e,f){if(e){a.getLogger().error("Server:initServer","DB configuration is not done properly!!!");a.emit("db.error",e)}else{a._dbInstance=f;if(a.listeners("configuration.ready").length>0){a.emit("configuration.ready")}else{a.emit("db.init")}}})}else{logger.getInstance().info("Simple Portal -db","DB configuration is not done properly!!!");callback("DB configuration is not done properly!!!")}a.router=simpleportal.router;a.use(new StartupLoader({},a));a.use(new OauthLoader({},a));a.use(new FilterLoader({},a));a.use(new Serviceloader({},a));a.use(new ViewLoader({},a));a.use(new PluginLoader(a.options,a));if(a.getConfiguration("openurl")){a.on("start",function(){var f=require("child_process").spawn;var e=a.getServerUrl();if(e){f("open",[e])}})}};Server.prototype.use=function(b){var a=this;if(b&&b.routerid&&a[b.routerid]){a.getLogger().warn("Server.use",b.routerid+" already registered.");return}if(b&&b.routerid){a.getLogger().debug("Server.use",b.routerid+" in to the router list.");a._routers.push(b.routerid);a[b.routerid]=b}if(b instanceof Routerclass){if(typeof a.routerCount!="number"){a.routerCount=0}if(typeof a.finishedRouterCount!="number"){a.finishedRouterCount=0}if(typeof a.finishedRouterLoadedCount!="number"){a.finishedRouterLoadedCount=0}a.routerCount++;a.on("router.loaded",function(){a.getLogger().debug("Server:use@event[router.loaded]","server router.loaded event is fired.");b.initAll.apply(b)});a.on("db.init",function(c){b.on("router.init",function(){a.finishedRouterCount++;if(a.finishedRouterCount==a.routerCount){a.getLogger().debug("Server.Router@event[router.init]","callback from all ["+a.routerCount+"]Server.Router@event[router.init]");a.emit("services.ready")}});b.on("router.loaded",function(){a.finishedRouterLoadedCount++;if(a.finishedRouterLoadedCount==a.routerCount){a.getLogger().debug("Server.Router@event[router.loaded]","callback from all ["+a.routerCount+"]Server.Router@event[router.loaded]");a.emit("router.loaded")}});b.initServer(a,function(){})})}else{simpleportal.util.callModuleFunction(b,true,"init",a,function(){})}if(b instanceof Routerclass){a.on("server.ready",function(){b.emit("server.ready",a)})}};Server.prototype.request=function(b){var a=this;a.router.dispatch.addUrlHandler(b)};Server.prototype.post=function(f,g){var a=this;var d=[];var b;var c=f.indexOf("/:");if(f.indexOf("/:")!=-1){b=f.substring(c+2);var e=b.indexOf("/");if(e!=-1){b=b.substring(0,e)}}d["POST "+f]=function(i,k,h,j){i.params=i.params||{};i.path=i.path||{};if(j){i.params[b]=j;i.path[b]=j;i.pathGroup=j}g(i,k,h)};a.router.dispatch.addUrlHandler(d)};Server.prototype.get=function(f,g){var a=this;var d=[];var b;var c=f.indexOf("/:");if(f.indexOf("/:")!=-1){b=f.substring(c+2);var e=b.indexOf("/");if(e!=-1){b=b.substring(0,e)}}d[f]=function(i,k,h,j){i.params=i.params||{};i.path=i.path||{};if(j){i.params[b]=j;i.path[b]=j;i.pathGroup=j}g(i,k,h)};a.router.dispatch.addUrlHandler(d)};Server.prototype.enable=function(c,b){var a=this;if(b!=false){a.options[c]=true}else{a.options[c]=false}};Server.DEFAULTS={"resources-simpleportal":true,"mode-configuration":false,coredir:__dirname+"/../../server"};Server.CONNECT="connect";Server.REST_SERVER="rest_server";Server.WEB_SERVER="web_server";Server.prototype.getConfiguration=function(a,b){if(a){return this._configuration[a]||b}else{return this._configuration}};Server.prototype.setConfiguration=function(c,d){var a=this;if(c&&typeof c!="object"&&d){this._configuration[c]=d}else{if(typeof c=="object"){simpleportal.util.extendJSON(this._configuration,c);if(c&&c.preference){a.emit("preference.change",c.preference)}}}if(a.getRouter("logger")&&typeof c=="object"&&c.hasOwnProperty("logger")&&c.hasOwnProperty("logger")){var b=c.logger;if(b.logtype){a.getRouter("logger").setConfiguration("logtype",b.logtype)}if(b.console){a.getRouter("logger").setConfiguration("console",b.console)}}};Server.prototype.getDBPool=function(){return this.dbpool};Server.prototype.getDBInstance=function(b,a){if(b&&typeof b=="string"){this.dbpool.getInstance(b,a)}else{if(b){this.dbpool.getInstance("default",b)}else{return this._dbInstance}}};Server.prototype.getStorageServiceInstance=function(a,b){if(b){b(null,new simpleportal.Service.StorageService(a,this))}else{return new simpleportal.Service.StorageService(a,this)}};Server.prototype.getLogger=function(){return this.logger};Server.prototype.useStaticRouter=function(b,c){var a=this;if(b&&c){this.server.use(b,connect["static"](c))}};Server.prototype.getServer=function(){return this["server"]};Server.prototype.getRouter=function(a){return this[a]};Server.prototype.getServerPort=function(b){var a=this;if(b){return a.getConfiguration("port")}else{if(a.getConfiguration("port")=="80"||a.getConfiguration("port")=="443"){return""}else{if(a.getConfiguration("hidePort")){return""}else{return a.getConfiguration("port")}}}};Server.prototype.getServerUrl=function(c,d){var a=this;var b=simpleportal.util.copyJSON({},["host","port","secure"],a.getConfiguration());if(b.host=="localhost"&&d){b.host=a.getConfiguration("hostip",b.host)}if(a.getConfiguration("hidePort")){b.port=a.getConfiguration("secure")?443:80}if(c){b.path=c}return simpleportal.util.constructUrl(b)};Server.prototype.getServerData=function(b){var a={themes:[],curtheme:{},layout:{}};b(a)};Server.prototype.getServerCorePath=function(f,e,d,c,b){var a=this;return path.normalize(simpleportal.util.appendFilePath(a.options.coredir,f,e,d,c,b))};Server.prototype.getTempDirectory=function(g,f,e,d,b){var a=this;var c=this.getConfiguration("resources").tempdir||"._tmp";return a.getDataDirectory(c,g,f,e,d,b)};Server.prototype.getDataDirectory=function(e,d,c,b,a){var f=this.getConfiguration("resources").datadir||"data";f=simpleportal.util.getServerPath(f);return simpleportal.util.appendFilePath(f,e,d,c,b,a)};Server.prototype.removeServerAction=function(a){if(!this._serveractions){this._serveractions=[]}if(simpleportal.util.jsonarraycontains(this._serveractions,"action",a)){this._serveractions=this._serveractions.filter(function(b){return b.action==a})}};Server.prototype.registerServerAction=function(a){if(!this._serveractions){this._serveractions=[]}if(!simpleportal.util.jsonarraycontains(this._serveractions,"action",a.action)){this._serveractions.push(a)}};Server.prototype.getServerActions=function(){return this._serveractions};function setDynamicPage(b,g,a,f,c,e){if(g){if(g.lastIndexOf("/")==g.length-1){g=g.substring(0,g.length-1)}}var d=a+g;if(d.indexOf("?")!=-1){d=d.substring(0,d.indexOf("?"))}if(d.indexOf(".html")==-1){d=d+".html"}fs.stat(d+".ejs",function(h){if(!h){f.publicpagelayout=d+".ejs"}e()})}function sendDynamicPage(j,f,e,d,g){var b=j.getServerCorePath("resources/templates/public");var h=b+"/index.html.ejs";if(e.publicpagelayout){var i={file:h,exceptionfile:b+"/exception.html.ejs",data:simpleportal.util.extendJSON({htmlfile:"/pages"+e.url,templatedir:b,pagelayout:e.publicpagelayout,webappuri:"/pages"+f,curtime:moment().format("MMMM Do YYYY, h:mm:ss a"),serverconfig:j.getConfiguration(),systemconfig:simpleportal.getConfiguration(),userprofile:e.getUserprofile()})};var c=j.getConfiguration("resources",{});if(c&&c.defaulttheme){i.data.themeconfig=j.getRouter("pluginloader").getPluginDetails(c.defaulttheme,"theme")}if(f.indexOf(".html")!=-1){i.file=e.publicpagelayout;delete i.data.pagelayout}var a=new Template(i);a.render(d)}else{g()}}var updateWebpages=function(a,d,c){var b="/pages";simpleportal.util.getResources(a,{resourcekey:"public",includeroot:false,extension:".html.ejs"},function(f,e){if(e&&e.length>0){for(var g in e){delete e[g].path;e[g].uri=b+e[g].id.replace(".html.ejs","");e[g].id=e[g].id.replace(".html.ejs","").replace("/","");if(e[g].display){e[g].display=e[g].display.replace(".html.ejs","")}if(!e[g].status){e[g].status="active"}var h=simpleportal.util.getJSONObject(d.webpages,"id",e[g].id);if(!h){e[g].hidden=true;d.webpages.push(e[g])}else{if(h.display){e[g].display=h.display}simpleportal.util.extendJSON(h,e[g])}}}if(c){c()}},[])};var updateServerWebpages=function(a){var b=a.getConfiguration();if(b&&!b.webpages){b.webpages=[{header:true,url:"",uri:(typeof b.loginuri!=="undefined"?b.loginuri:"/signin"),icon:"glyphicon glyphicon-log-in",id:"login",signin:false},{header:true,url:"",uri:(typeof b.logouturi!=="undefined"?b.logouturi:"/logout"),icon:"glyphicon glyphicon-off",id:"logout",signin:true}]}updateWebpages(a.getServerCorePath("resources/templates/public/pages"),b,function(){updateWebpages(simpleportal.util.getServerPath("resources/templates/public/pages"),b,function(){if(b.logouturi){var d=simpleportal.util.getJSONObject(b.webpages,"id","logout");d.uri=b.logouturi}if(b.loginuri){var c=simpleportal.util.getJSONObject(b.webpages,"id","signin");c.uri=b.loginuri}if(b.termsofserviceuri){var e=simpleportal.util.getJSONObject(b.webpages,"id","terms-of-service");if(e){e.uri=b.termsofserviceuri}}})})};var registerPublicPageMapping=function(a,b){for(var c in b){registerPublicPage(a,b[c])}};var registerPublicPage=function(a,b){a.server.use(b.url,function(e,c,d){sendTemplatePage(a,a.getServerCorePath("resources/templates/public",b.path),b.uri,e,c,d)})};var sendTemplatePage=function(j,g,a,e,d,f){if(e.url=="/"||/(\.html|\.css|\.js)$/.test(e.url)){var i="index.html.ejs";if(/(\.html|\.css|\.js)$/.test(e.url)){if(e.url.indexOf("?")!=-1){i=e.url.substring(0,e.url.indexOf("?"))+".ejs"}else{i=e.url+".ejs"}}var h=j.getConfiguration("resources").defaulttheme;var c=j.getRouter("pluginloader").getPluginDetails(h,"theme");var b=new Template({file:g+"/"+i,data:simpleportal.util.extendJSON({themeconfig:c,webappuri:a,curtime:moment().format("MMMM Do YYYY, h:mm:ss a")},{serverconfig:j.getConfiguration(),systemconfig:simpleportal.getConfiguration()},{userprofile:e.getUserprofile()})});b.render(d)}else{f()}};